#ifndef AOCOLOR_H
#define AOCOLOR_H

#include <qvariant.h>
#include <qvaluelist.h>

class QString;
class QColor;

class AOColor
{
public:
	AOColor(void);
	virtual ~AOColor(void);

	enum ColorType{ String, Hex3, Hex4 };

	void setName( QString name ) { Name = name; }
	QString name() { return Name; }

	void setColor( QString color );
	void setColor( QColor color );
	QString value() { return Color; }
	QColor color();

protected:
	QString Name;
	QString Color;
	ColorType Type;
	int r;
	int g;
	int b;
};

typedef QValueList<AOColor> AOColors;

#endif // AOCOLOR_H