/****************************************************************************
** Form implementation generated from reading ui file 'basedlg.ui'
**
** Created: sø 13. mar 22:46:32 2005
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.2.1   edited May 19 14:22 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "basedlg.h"

#include <qvariant.h>
#include <qtabwidget.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlistview.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qstring.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcolordialog.h>
#include <qfiledialog.h>
#include <qfile.h>
#include <qxml.h>
#include <qdom.h>

#include "AOcrayon.xpm"

QString GUIPath( "/cd_image/gui/Default/" );
QString TextColorFile( "TextColors.xml" );

/*
 *  Constructs a BaseDlg as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
BaseDlg::BaseDlg( QString path, QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "BaseDlg" );
	setIcon( QPixmap( AOcrayon_xpm ) );
    BaseDlgLayout = new QVBoxLayout( this, 6, 4, "BaseDlgLayout"); 

	TabWidget = new QTabWidget( this, "TabWidget" );
	TabWidget->setMargin( 6 );

	/*
	 * Chat color list
	 */
    ColorsTab = new QWidget( this, "ColorsTab" );
    ColorsTabLayout = new QVBoxLayout( ColorsTab );
	ColorsTabLayout->setSpacing( 4 );
	ColorsTabLayout->setMargin( 0 );

    ColorsList = new QListView( ColorsTab, "ColorsList" );
    ColorsList->header()->setClickEnabled( FALSE );
    ColorsList->header()->setResizeEnabled( FALSE );
	ColorsList->addColumn( "", 0 );
    ColorsList->addColumn( tr( "Color group" ), 155 );
    ColorsList->addColumn( tr( "Color" ), 75 );
	ColorsList->addColumn( "", 85 );
	ColorsList->setColumnAlignment( 3, Qt::AlignCenter );
    ColorsList->setLineWidth( 1 );
	ColorsList->setAllColumnsShowFocus( TRUE );
	ColorsList->setSorting( -1 );
//	ColorsList->viewport()->setPaletteBackgroundColor( QColor( "gray" ) );
    ColorsTabLayout->addWidget( ColorsList );

	PickColorBtn = new QPushButton( ColorsTab, "PickColorBtn" );
	PickColorBtn->setAutoDefault( FALSE );
    ColorsTabLayout->addWidget( PickColorBtn );

	TabWidget->addTab( ColorsTab, "Chat Colors" );

	/*
	 * Settings
	 */

	SettingsTab = new QWidget( this, "SettingsTab" );
	SettingsTabLayout = new QGridLayout( SettingsTab );
	SettingsTabLayout->setSpacing( 3 );
	SettingsTabLayout->setMargin( 0 );

	AOPathLabel = new QLabel( SettingsTab, "AOPathLabel" );
	SettingsTabLayout->addWidget( AOPathLabel, 0, 0 );

	AOPathBox = new QLineEdit( SettingsTab, "AOPathBox" );
	SettingsTabLayout->addWidget( AOPathBox, 0, 1 );

	AOPathBtn = new QPushButton( SettingsTab, "AOPathBtn" );
	SettingsTabLayout->addWidget( AOPathBtn, 0, 2 );

	AOPathErrorLabel = new QLabel( SettingsTab, "AOPathErrorLabel" );
	SettingsTabLayout->addMultiCellWidget( AOPathErrorLabel, 1, 1, 0, 2 );

	ReloadBtn = new QPushButton( SettingsTab, "ReloadBtn" );
	SettingsTabLayout->addMultiCellWidget( ReloadBtn, 2, 2, 0, 2 );

	QFrame * Hline = new QFrame( SettingsTab );
	Hline->setFrameStyle( QFrame::HLine | QFrame::Sunken );
	SettingsTabLayout->addMultiCellWidget( Hline, 3, 3, 0, 2 );

	QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
	SettingsTabLayout->addItem( spacer, 5, 0 );

	TabWidget->addTab( SettingsTab, "Settings" );

	/*
	 * About text
	 */
	AboutTab = new QWidget( this, "AboutTab" );
	AboutTabLayout = new QVBoxLayout( AboutTab );
	AboutTabLayout->setSpacing( 3 );
	AboutTabLayout->setMargin( 0 );

	AboutLabel = new QLabel( AboutTab, "AboutLabel" );
	AboutLabel->setFrameStyle( QFrame::Box | QFrame::Sunken );
	AboutLabel->setIndent( 5 );
	AboutTabLayout->addWidget( AboutLabel );

	TabWidget->addTab( AboutTab, "About..." );

    BaseDlgLayout->addWidget( TabWidget );

    SysLayout = new QHBoxLayout( 0, 0, 4, "SysLayout"); 
    QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    SysLayout->addItem( spacer_2 );

    OkBtn = new QPushButton( this, "OkBtn" );
    OkBtn->setDefault( TRUE );
    SysLayout->addWidget( OkBtn );

    CancelBtn = new QPushButton( this, "CancelBtn" );
    SysLayout->addWidget( CancelBtn );
    BaseDlgLayout->addLayout( SysLayout );
    languageChange();
    resize( QSize(360, 400).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( OkBtn, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( CancelBtn, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( ColorsList, SIGNAL( doubleClicked(QListViewItem*) ), this, SLOT( pickColor(QListViewItem*) ) );
	connect( PickColorBtn, SIGNAL( clicked() ), this, SLOT( pickColor() ) );
	connect( AOPathBtn, SIGNAL( clicked() ), this, SLOT( browseAOPath() ) );
	connect( AOPathBox, SIGNAL( textChanged(const QString&) ), this, SLOT( setAOPath(const QSTring&) ) );

	setAOPath( path );
	while( AOPath.isEmpty() || !QFile::exists( AOPath + GUIPath + TextColorFile ) )
	{
		browseAOPath();
	}
	loadData();
}

/*
 *  Destroys the object and frees any allocated resources
 */
BaseDlg::~BaseDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void BaseDlg::languageChange()
{
    setCaption( tr( "AOcrayon" ) );
    TabWidget->setTabLabel( ColorsTab, tr( "Chat Colors" ) );
	TabWidget->setTabLabel( SettingsTab, tr( "Settings" ) );
    TabWidget->setTabLabel( AboutTab, tr( "About..." ) );
    ColorsList->header()->setLabel( 1, tr( "Color group" ) );
    ColorsList->header()->setLabel( 2, tr( "Color" ) );
    PickColorBtn->setText( tr( "&Pick color" ) );
    PickColorBtn->setAccel( QKeySequence( tr( "Alt+P" ) ) );

	AOPathLabel->setText( tr( "AO Install Dir:" ) );
	AOPathBtn->setText( tr( "..." ) );
	AOPathErrorLabel->setText( tr( "<font color=red><b>Selected path is not a valid AO installation!</b></font>" ) );
	ReloadBtn->setText( tr( "Reload Chat color data" ) );

	AboutLabel->setText( tr( 
		"<b><font size=6 color=blue><center>AOcrayon v0.1</center></font></b>"
		"<font color=blue><center>&copy; Copyright 2005 Mawerick</center></font>"
		"AOcrayon is a third-party tool that was made with the intent to help<br />"
		" players of Anarchy Online change their chat text colors easily,<br />"
		" without mucking about with complex xml file editing.<br />"
		"Get the latest version at <a href='http://www.wrongplace.net/'>http://www.wrongplace.net/</a><br /><br />"
		"<b><u>Credits:</u></b><br />"
		"Special thanks to Oofbig for suggesting the name :)<br /><br />"
		"<b><u>Color groups explained:</u></b><br />"
		"* The top 15 or so groups are just definitions for standard colors.<br />"
		"\tIt's best to just leave these alone...<br />"
		"* The groups starting with <font color=red>ct_</font> are internal colors. Do as above.<br />"
		"* Groups starting with <font color=red>CC</font><br />  are used in various dialogs and other parts of the GUI<br />"
		"\t(i.e. <font color=red>CCNPCChatColorEmote</font>)<br />"
		"* Groups starting with <font color=red>ctch_</font> are the various chat groups.<br />"
		"\t(i.e. <font color=red>ctch_clan</font> is your guild channel etc.)"
		) );

    OkBtn->setText( tr( "&Ok" ) );
    OkBtn->setAccel( QKeySequence( tr( "Alt+O" ) ) );
    CancelBtn->setText( tr( "&Cancel" ) );
    CancelBtn->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

void BaseDlg::browseAOPath()
{
    QString path = QFileDialog::getExistingDirectory( AOPath, this, "AOPathDlg", tr( "Locate AO Install directory" ), TRUE );
	path.replace( "/", "\\" );
	path.replace( 0, 1, path[0].upper() );
	setAOPath( path );
}

void BaseDlg::setAOPath( const QString &path )
{
	AOPath = path;
	AOPathBox->setText( path );
	if( QFile::exists( AOPath + GUIPath + TextColorFile ) )
	{
		AOPathErrorLabel->hide();
		ReloadBtn->show();
	}
	else
	{
		AOPathErrorLabel->show();
		ReloadBtn->hide();
	}
}

void BaseDlg::loadData()
{
	QDomDocument xmlDoc;
	Colors.clear();
	qDebug( "loadData(): file: %s%s%s", AOPath.latin1(), GUIPath.latin1(), TextColorFile.latin1() );
	QFile TextColors( AOPath + GUIPath + TextColorFile );
	if( TextColors.open( IO_ReadOnly ) )
	{
		if( xmlDoc.setContent( &TextColors ) )
		{
			QDomNodeList nodeList = xmlDoc.elementsByTagName( "HTMLColor" );
			for( int i = 0; i < (int) nodeList.count(); i++ )
			{
				AOColor color;
				QDomNode node = nodeList.item( i );
				QDomElement element = node.toElement();

				color.setName( element.attribute( "name" ) );
				color.setColor( element.attribute( "color" ) );
				Colors.append( color );
			}
		}
		TextColors.close();
	}
	updateColorList();
}

void BaseDlg::saveData()
{
	QDir GUIDir( AOPath + GUIPath );
	QFile XmlFile( GUIDir.filePath( TextColorFile ) );
	GUIDir.remove( TextColorFile + ".bak", FALSE );
	GUIDir.rename( TextColorFile, TextColorFile + ".bak", FALSE );
	if( XmlFile.open( IO_WriteOnly ) )
	{
	    QDomDocument doc( "" );
		QDomElement root = doc.createElement( "Root" );
		doc.appendChild( root );

		for( AOColors::iterator it = Colors.begin(); it != Colors.end(); it++ )
		{
			QDomElement tag = doc.createElement( "HTMLColor" );
			tag.setAttribute( "name", (*it).name() );
			tag.setAttribute( "color", (*it).value() );
			root.appendChild( tag );
		}

		QString xml = doc.toString( 4 );
		qDebug( "Test:\n%s", xml.latin1() );

		QTextStream stream( &XmlFile );
		stream << xml;
		XmlFile.close();
	}
}

void BaseDlg::updateColorList()
{
	ColorsList->clear();
	QListViewItem * item = 0;
	int n = 0;
	for( AOColors::iterator it = Colors.begin(); it != Colors.end(); it++, n++ )
	{
		item = new QListViewItem( ColorsList, item );
		item->setText( 0, QString( "%1" ).arg( n ) );
		item->setText( 1, (*it).name() );
		item->setText( 2, (*it).value() );

		QColor col( (QColor) (*it).color() );
		if( col.isValid() )
		{
			QPixmap *temp = new QPixmap( 75, 15 );
			temp->fill( col );
			item->setPixmap( 3, *temp );
		}
	}
}

void BaseDlg::pickColor( QListViewItem* item )
{
	int index = item->text(0).toInt();
	AOColor& color = Colors[index];
	QColor newColor = QColorDialog::getColor( color.color(), this );
	if( newColor.isValid() )
	{
		color.setColor( newColor );
		updateColorList();
	}
}

void BaseDlg::pickColor()
{
	if( QListViewItem * item = ColorsList->currentItem() )
	{
		pickColor( item );
	}
}
